/* demtod1.c -- Convert a USGS-format DEM file to an intermediate "D1"
 * format which is easier for a C program to read, eg the d1topgm.c
 * program which generates a standard PGM-ascii pixmap image.
 * Original author: Christopher Keane <keane@earthsun.umd.edu>
 * Slight mods:     John Beale <beale2jumpjibe.stanford.edu> Nov. 30 1995
 */

#include <stdio.h>
#include <string.h>

int do_parse(char *infile);
int getkey();

int main( int argc, char **argv )
{  
char infile[24];
char outfile[24];

FILE *InDEM, *OutDEM;
unsigned count;
int i10;
char ic, ic1;

if( argc == 2 )
  {
  strcpy( infile, argv[1] );
  strcpy( outfile, "temporary.temporary" );
}else{

  printf("Please enter the name of the DEM file to read:");
  gets( infile );
  strcpy( outfile, "temporary.temporary");
}

if ((InDEM = fopen(infile,"rb")) == NULL)
	 {
	  fprintf(stderr,"Cannot open DEM input file: %s\n",infile);
	  exit(-1);
	  }
	if ((OutDEM = fopen(outfile,"wb")) == NULL)
	 {
	  fprintf(stderr,"Cannot create output file\n");
	  exit(-1);
	  }

	i10 = 0;
	count = 0;
	ic = fgetc(InDEM);

	while (!feof(InDEM))
	 {
	  ic1 = ic;
	  ic = fgetc(InDEM);
	  if (((ic == '-') || (ic == '+')) && (ic1 == 'D'))
	  {
	   count++;
	   i10++;
	   if (i10 > 99) {
		i10 = 0;
		printf("Precision Change #%d\r",count); 
		fflush(stdout);
	   }
	   fputc('E',OutDEM);
	  }
	  else fputc(ic1,OutDEM);
	 }
	fputc(ic,OutDEM);
	fclose(InDEM);
	fclose(OutDEM);

 printf("\n");
 do_parse( infile );

return(0);
}

int do_parse(char *infile)
{
FILE *f1, *f2; 
char filename1[25], *filename2, name[60];
int code, junk, i, profiles, points;
double coord, junk1;
float junk2;
int x, y, i10;

strcpy( filename1, "temporary.temporary");
filename2 = strcat( infile, ".d1" );

f1 = fopen( filename1, "r");
if( f1 == NULL )
        {
        puts("Error in opening file....");
        exit(0);
        }
f2 = fopen( filename2, "wb");

fgets( name, 40, f1 );          /* read in the DEM file name */
fseek( f1, 145, 0);             /* skip all kinds of trash */
fscanf( f1, " %d", &code );      /* Read in Level Code */
fscanf( f1, " %d", &code );      /* read in Pattern Code */
fscanf( f1, " %d", &code );      /* read in planimetric system */
fscanf( f1, " %d", &junk);

for( i=0; i<15; i++){
  fscanf( f1, " %lf", &junk1 );
}

fscanf( f1, " %d", &code );   /* read in planar unit of measure */
fscanf( f1, " %d", &code );   /* read in elevation unit of measure */
fscanf( f1, " %d", &junk);

for( i=0; i<4; i++){          /* read in corner points */
  fscanf( f1, " %lf", &coord);
  fprintf(f2, "%f\n", coord);
  fscanf( f1, " %lf", &coord);
  fprintf(f2, "%f\n", coord);
  }

fscanf( f1, " %lf", &junk1);
fprintf(f2, "%f\n", junk1 );

fscanf( f1, " %lf", &junk1);
fprintf(f2, "%f\n", junk1 );

fscanf( f1, " %lf", &junk1 );
fscanf(f1, " %d", &code );
fscanf(f1,  " %f %f %f", &junk2, &junk2, &junk2);
fscanf(f1, " %d %d", &points, &profiles );
fprintf(f2, "%d\n", profiles);

i10=0;
for( x=0; x<profiles; x++)      /* loop for all profiles */
{
  i10++;
  if (i10 > 9) {
    i10 = 0;
    printf("Profile #%d\r", x);
    fflush(stdout);
  }
  fscanf(f1, " %d %d", &junk, &code );
  fprintf(f2, "%d\n", code );

  fscanf(f1, " %d %d", &points, &junk );
  fprintf(f2, "%d\n", points);
  fscanf( f1, " %lf %lf", &junk1, &coord);
  fprintf(f2, "%f %f\n", junk1, coord);
  fscanf( f1, " %lf", &junk1 );
  fscanf( f1, " %lf %lf", &junk1, &coord ); 

  for( y=0; y<points; y++)
  {
  fscanf( f1, " %d", &code );
  fprintf(f2, "%d\n", code );
  }

 }
 printf("\n");
 printf("The parsing of the file is finished....\n");
 fclose( f1 );
 fclose(f2);
 unlink( filename1);
 return(0);

} /* end do_parse() */

int getkey()
{
char buffer[40];

gets( buffer );
return(0);
}

